package com.uas.erp.schedular.api.v1;

import com.uas.erp.schedular.entity.Setting;
import com.uas.erp.schedular.service.SettingService;
import com.uas.erp.schedular.web.ResponseWrap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.util.Assert;
import org.springframework.web.bind.annotation.*;

/**
 * Created by Pro1 on 2017/6/22.
 */
@RestController
@RequestMapping(path = "/v1/setting")
public class SettingControllerV1 {

    @Autowired
    private SettingService settingService;

    /**
     * 取配置列表
     * @return
     */
    @GetMapping(path = "/list")
    public ResponseEntity getSettings() {
        return ResponseWrap.ok(settingService.findAll());
    }

    @GetMapping(path = "/{key}")
    public ResponseEntity getSetting(@PathVariable("key") String key) {
        return ResponseWrap.ok(settingService.findOne(key));
    }

    @PostMapping
    public ResponseEntity saveSetting(Setting setting) {
        settingService.save(setting);
        return ResponseWrap.ok();
    }

    @DeleteMapping(path = "/{key}")
    public ResponseEntity deleteSetting(@PathVariable("key") String key) {
        Setting setting = settingService.findOne(key);
        Assert.notNull(setting);
        settingService.delete(setting);
        return ResponseWrap.ok();
    }

}
