package com.uas.erp.schedular.b2b.domain;

import java.io.Serializable;
import java.util.Date;

/**
 *  用于招标中的企业基本信息
 * Created by dongbw on 17/03/07 11:50.
 */

public class EnterpriseBaseInfo implements Serializable {

    /**
     * 序列号
     */
    private static final long serialVersionUID = 1L;

    /**
     * 企业uu
     */
    private Long uu;

    /**
     * 公司名称
     */
    private String enName;

    /**
     * 注册地址
     */
    private String enAddress;

    /**
     * 企业执照号
     */
    private String enBusinessCode;

    /**
     * 成立时间
     */
    private Date enEstablishDate;

    /**
     * 员工人数
     */
    private Long emNum;

    /**
     * 公司电话
     */
    private String enTel;
    /**
     * 传真
     */
    private String enFax;

    /**
     * 联系人（暂时设置为企业系统管理员）
     */
    private String enUser;

    /**
     * 联系人电话
     */
    private String userTel;

    /**
     * 开户行
     */
    private String bank;

    /**
     * 经营范围
     */
    private String scope;

    /**
     * 备注
     */
    private String remark;

    public EnterpriseBaseInfo(Long uu, String enBusinessCode, String enName, String enAddress) {
        this.uu = uu;
        this.enBusinessCode = enBusinessCode;
        this.enName = enName;
        this.enAddress = enAddress;
    }

    public EnterpriseBaseInfo() {
    }

    public Long getUu() {
        return uu;
    }

    public void setUu(Long uu) {
        this.uu = uu;
    }

    public String getEnName() {
        return enName;
    }

    public void setEnName(String enName) {
        this.enName = enName;
    }

    public String getEnAddress() {
        return enAddress;
    }

    public void setEnAddress(String enAddress) {
        this.enAddress = enAddress;
    }

    public String getEnBusinessCode() {
        return enBusinessCode;
    }

    public void setEnBusinessCode(String enBusinessCode) {
        this.enBusinessCode = enBusinessCode;
    }

    public Date getEnEstablishDate() {
        return enEstablishDate;
    }

    public void setEnEstablishDate(Date enEstablishDate) {
        this.enEstablishDate = enEstablishDate;
    }

    public Long getEmNum() {
        return emNum;
    }

    public void setEmNum(Long emNum) {
        this.emNum = emNum;
    }

    public String getEnTel() {
        return enTel;
    }

    public void setEnTel(String enTel) {
        this.enTel = enTel;
    }

    public String getEnFax() {
        return enFax;
    }

    public void setEnFax(String enFax) {
        this.enFax = enFax;
    }

    public String getEnUser() {
        return enUser;
    }

    public void setEnUser(String enUser) {
        this.enUser = enUser;
    }

    public String getUserTel() {
        return userTel;
    }

    public void setUserTel(String userTel) {
        this.userTel = userTel;
    }

    public String getBank() {
        return bank;
    }

    public void setBank(String bank) {
        this.bank = bank;
    }

    public String getScope() {
        return scope;
    }

    public void setScope(String scope) {
        this.scope = scope;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }
}
