package com.uas.erp.schedular.b2b.domain;


import java.util.Date;

/**
 * 供应商绩效考核
 *
 * @author huangct
 * @date 2017年10月12日
 * @modify-author hejq
 * @modify-date 2018-08-03 11:01
 * @modify-desc 增加备注信息，将数据传输方法写在轮询项目里面
 */
public class VendorPerformanceAssess extends KeyEntity {

	/**
	 * 编号
	 */
	private String vpa_code;

	/**
	 * ID
	 */
    private Long vpa_id;

	/**
	 * 单据状态
	 */
	private String vpa_status;

	/**
	 * 录入人
	 */
    private String vpa_recordman;

	/**
	 * 录入日期
	 */
	private Date vpa_recorddate;

	/**
	 * 状态码
	 */
    private String vpa_statuscode;

	/**
	 * 申请人
	 */
	private String vpa_applyman;

	/**
	 * 申请部门
	 */
    private String vpa_applydep;

	/**
	 * 申请日期
	 */
	private Date vpa_applydate;

	/**
	 * 考核期间
	 */
    private String vpa_assessdate;

	/**
	 * 采购跟单
	 */
	private String vpa_purchasecode;

	/**
	 * SQE
	 */
    private String vpa_sqe;

	/**
	 * 物料认定组
	 */
	private String vpa_orderteam;

	/**
	 * 供应商号
	 */
    private String vpa_vendorcode;

	/**
	 * 供应商名
	 */
	private String vpa_vendorname;

	/**
	 * 物料类别
	 */
    private String vpa_prodkind;

	/**
	 * 来料批不合格率(15分)
	 */
	private Double vpa_llpbhgl;

	/**
	 * 上线不良率(25分)
	 */
    private Double vpa_sxbll;

	/**
	 * 客户失效次数(10分)
	 */
	private Double vpa_khsxcs;

	/**
	 * 产线重大异常(10分)
	 */
    private Double vpa_cxzdyc;

	/**
	 * 8D回复及时率(5分)
	 */
	private Double vpa_8dhfjsl;

	/**
	 * 异常复发率(10分)
	 */
    private Double vpa_ycffl;

	/**
	 * 供方配合度(25分)
	 */
	private Double vpa_gfphd;

	/**
	 * 质量综合得分
	 */
    private Double vpa_zlzhdf;

	/**
	 * 质量权重得分（30%）
	 */
	private Double vpa_zlqzdf;

	/**
	 * 技术支持(10分)
	 */
    private Double vpa_jszc;

	/**
	 * 技术标准(10分)
	 */
	private Double vpa_jsbz;

	/**
	 * 技术分析(10分)
	 */
    private Double vpa_jsfx;

	/**
	 * 技术资料完整情况(15分)
	 */
	private Double vpa_jszlwzqk;

	/**
	 * 样品合格率(5分)
	 */
    private Double vpa_yphgl;

	/**
	 * 研发/工程实力(10分)
	 */
	private Double vpa_gcsl;

	/**
	 * 可靠性要求/条件(20分)
	 */
    private Double vpa_kkxyq;

	/**
	 * 物料是否发生技术质量问题(20分)
	 */
	private Double vpa_wlsffsjszlwt;

	/**
	 * 技术综合得分
	 */
    private Double vpa_jszhdf;

	/**
	 * 技术权重得分(30%)
	 */
	private Double vpa_jsqzdf;

	/**
	 * 成本降价(50分)
	 */
    private Double vpa_cbjj;

	/**
	 * 支付条件(20分)
	 */
	private Double vpa_zftj;

	/**
	 * 打样支持(15分)
	 */
    private Double vpa_dyzc;

	/**
	 * 服务支持(15分)
	 */
	private Double vpa_fwzc;

	/**
	 * 采购开发综合得分
	 */
    private Double vpa_cgkfzhdf;

	/**
	 * 物料交付(50分)
	 */
	private Double vpa_wljf;

	/**
	 * 停线/调计划次数(30分)
	 */
    private Double vpa_djhcs;

	/**
	 * NG品处理(10分)
	 */
	private Double vpa_ngpcl;

	/**
	 * 服务响应(10分)
	 */
    private Double vpa_fwxl;

	/**
	 * 采购综合得分
	 */
	private Double vpa_cgzhdf;

	/**
	 * 采购及采购开发权重得分(各20%)
	 */
    private Double vpa_cgjcgkfqzdf;

	/**
	 * 总计得分
	 */
	private Double vpa_zjdf;

	/**
	 * 供应商确认得分
	 */
    private String vpa_gysqrdf;

	/**
	 * 不认可原因
	 */
	private String vpa_brkyy;

	/**
	 * 质量评分附件
	 */
    private String vpa_zlpffj;

	/**
	 * 技术评分附件
	 */
	private String vpa_jspffj;

	/**
	 * 采购评分附件
	 */
    private String vpa_cgpffj;

	/**
	 * 审核日期
	 */
	private Date vpa_auditdate;

	/**
	 * 审核人
	 */
    private String vpa_auditor;

	/**
	 * 基本信息附件
	 */
	private String vpa_jbxxfj;

	/**
	 * 采购跟踪人
	 */
    private String vpa_purchasename;

	/**
	 * SQE人
	 */
	private String vpa_sqename;

	/**
	 * 物料认定人
	 */
    private String vpa_ordername;

	/**
	 * 供应商UU
	 */
	private Long ve_uu;

	/**
	 * 供应商等级
	 */
	private String vpa_grade;
    
	public String getVpa_code() {
		return vpa_code;
	}

	public void setVpa_code(String vpa_code) {
		this.vpa_code = vpa_code;
	}

	public Long getVpa_id() {
		return vpa_id;
	}

	public void setVpa_id(Long vpa_id) {
		this.vpa_id = vpa_id;
	}

	public String getVpa_status() {
		return vpa_status;
	}

	public void setVpa_status(String vpa_status) {
		this.vpa_status = vpa_status;
	}

	public String getVpa_recordman() {
		return vpa_recordman;
	}

	public void setVpa_recordman(String vpa_recordman) {
		this.vpa_recordman = vpa_recordman;
	}

	public Date getVpa_recorddate() {
		return vpa_recorddate;
	}

	public void setVpa_recorddate(Date vpa_recorddate) {
		this.vpa_recorddate = vpa_recorddate;
	}

	public String getVpa_statuscode() {
		return vpa_statuscode;
	}

	public void setVpa_statuscode(String vpa_statuscode) {
		this.vpa_statuscode = vpa_statuscode;
	}

	public String getVpa_applyman() {
		return vpa_applyman;
	}

	public void setVpa_applyman(String vpa_applyman) {
		this.vpa_applyman = vpa_applyman;
	}

	public String getVpa_applydep() {
		return vpa_applydep;
	}

	public void setVpa_applydep(String vpa_applydep) {
		this.vpa_applydep = vpa_applydep;
	}

	public Date getVpa_applydate() {
		return vpa_applydate;
	}

	public void setVpa_applydate(Date vpa_applydate) {
		this.vpa_applydate = vpa_applydate;
	}

	public String getVpa_assessdate() {
		return vpa_assessdate;
	}

	public void setVpa_assessdate(String vpa_assessdate) {
		this.vpa_assessdate = vpa_assessdate;
	}

	public String getVpa_purchasecode() {
		return vpa_purchasecode;
	}

	public void setVpa_purchasecode(String vpa_purchasecode) {
		this.vpa_purchasecode = vpa_purchasecode;
	}

	public String getVpa_sqe() {
		return vpa_sqe;
	}

	public void setVpa_sqe(String vpa_sqe) {
		this.vpa_sqe = vpa_sqe;
	}

	public String getVpa_orderteam() {
		return vpa_orderteam;
	}

	public void setVpa_orderteam(String vpa_orderteam) {
		this.vpa_orderteam = vpa_orderteam;
	}

	public String getVpa_vendorcode() {
		return vpa_vendorcode;
	}

	public void setVpa_vendorcode(String vpa_vendorcode) {
		this.vpa_vendorcode = vpa_vendorcode;
	}

	public String getVpa_vendorname() {
		return vpa_vendorname;
	}

	public void setVpa_vendorname(String vpa_vendorname) {
		this.vpa_vendorname = vpa_vendorname;
	}

	public String getVpa_prodkind() {
		return vpa_prodkind;
	}

	public void setVpa_prodkind(String vpa_prodkind) {
		this.vpa_prodkind = vpa_prodkind;
	}

	public Double getVpa_llpbhgl() {
		return vpa_llpbhgl;
	}

	public void setVpa_llpbhgl(Double vpa_llpbhgl) {
		this.vpa_llpbhgl = vpa_llpbhgl;
	}

	public Double getVpa_sxbll() {
		return vpa_sxbll;
	}

	public void setVpa_sxbll(Double vpa_sxbll) {
		this.vpa_sxbll = vpa_sxbll;
	}

	public Double getVpa_khsxcs() {
		return vpa_khsxcs;
	}

	public void setVpa_khsxcs(Double vpa_khsxcs) {
		this.vpa_khsxcs = vpa_khsxcs;
	}

	public Double getVpa_cxzdyc() {
		return vpa_cxzdyc;
	}

	public void setVpa_cxzdyc(Double vpa_cxzdyc) {
		this.vpa_cxzdyc = vpa_cxzdyc;
	}

	public Double getVpa_8dhfjsl() {
		return vpa_8dhfjsl;
	}

	public void setVpa_8dhfjsl(Double vpa_8dhfjsl) {
		this.vpa_8dhfjsl = vpa_8dhfjsl;
	}

	public Double getVpa_ycffl() {
		return vpa_ycffl;
	}

	public void setVpa_ycffl(Double vpa_ycffl) {
		this.vpa_ycffl = vpa_ycffl;
	}

	public Double getVpa_gfphd() {
		return vpa_gfphd;
	}

	public void setVpa_gfphd(Double vpa_gfphd) {
		this.vpa_gfphd = vpa_gfphd;
	}

	public Double getVpa_zlzhdf() {
		return vpa_zlzhdf;
	}

	public void setVpa_zlzhdf(Double vpa_zlzhdf) {
		this.vpa_zlzhdf = vpa_zlzhdf;
	}

	public Double getVpa_zlqzdf() {
		return vpa_zlqzdf;
	}

	public void setVpa_zlqzdf(Double vpa_zlqzdf) {
		this.vpa_zlqzdf = vpa_zlqzdf;
	}

	public Double getVpa_jszc() {
		return vpa_jszc;
	}

	public void setVpa_jszc(Double vpa_jszc) {
		this.vpa_jszc = vpa_jszc;
	}

	public Double getVpa_jsbz() {
		return vpa_jsbz;
	}

	public void setVpa_jsbz(Double vpa_jsbz) {
		this.vpa_jsbz = vpa_jsbz;
	}

	public Double getVpa_jsfx() {
		return vpa_jsfx;
	}

	public void setVpa_jsfx(Double vpa_jsfx) {
		this.vpa_jsfx = vpa_jsfx;
	}

	public Double getVpa_jszlwzqk() {
		return vpa_jszlwzqk;
	}

	public void setVpa_jszlwzqk(Double vpa_jszlwzqk) {
		this.vpa_jszlwzqk = vpa_jszlwzqk;
	}

	public Double getVpa_yphgl() {
		return vpa_yphgl;
	}

	public void setVpa_yphgl(Double vpa_yphgl) {
		this.vpa_yphgl = vpa_yphgl;
	}

	public Double getVpa_gcsl() {
		return vpa_gcsl;
	}

	public void setVpa_gcsl(Double vpa_gcsl) {
		this.vpa_gcsl = vpa_gcsl;
	}

	public Double getVpa_kkxyq() {
		return vpa_kkxyq;
	}

	public void setVpa_kkxyq(Double vpa_kkxyq) {
		this.vpa_kkxyq = vpa_kkxyq;
	}

	public Double getVpa_wlsffsjszlwt() {
		return vpa_wlsffsjszlwt;
	}

	public void setVpa_wlsffsjszlwt(Double vpa_wlsffsjszlwt) {
		this.vpa_wlsffsjszlwt = vpa_wlsffsjszlwt;
	}

	public Double getVpa_jszhdf() {
		return vpa_jszhdf;
	}

	public void setVpa_jszhdf(Double vpa_jszhdf) {
		this.vpa_jszhdf = vpa_jszhdf;
	}

	public Double getVpa_jsqzdf() {
		return vpa_jsqzdf;
	}

	public void setVpa_jsqzdf(Double vpa_jsqzdf) {
		this.vpa_jsqzdf = vpa_jsqzdf;
	}

	public Double getVpa_cbjj() {
		return vpa_cbjj;
	}

	public void setVpa_cbjj(Double vpa_cbjj) {
		this.vpa_cbjj = vpa_cbjj;
	}

	public Double getVpa_zftj() {
		return vpa_zftj;
	}

	public void setVpa_zftj(Double vpa_zftj) {
		this.vpa_zftj = vpa_zftj;
	}

	public Double getVpa_dyzc() {
		return vpa_dyzc;
	}

	public void setVpa_dyzc(Double vpa_dyzc) {
		this.vpa_dyzc = vpa_dyzc;
	}

	public Double getVpa_fwzc() {
		return vpa_fwzc;
	}

	public void setVpa_fwzc(Double vpa_fwzc) {
		this.vpa_fwzc = vpa_fwzc;
	}

	public Double getVpa_cgkfzhdf() {
		return vpa_cgkfzhdf;
	}

	public void setVpa_cgkfzhdf(Double vpa_cgkfzhdf) {
		this.vpa_cgkfzhdf = vpa_cgkfzhdf;
	}

	public Double getVpa_wljf() {
		return vpa_wljf;
	}

	public void setVpa_wljf(Double vpa_wljf) {
		this.vpa_wljf = vpa_wljf;
	}

	public Double getVpa_djhcs() {
		return vpa_djhcs;
	}

	public void setVpa_djhcs(Double vpa_djhcs) {
		this.vpa_djhcs = vpa_djhcs;
	}

	public Double getVpa_ngpcl() {
		return vpa_ngpcl;
	}

	public void setVpa_ngpcl(Double vpa_ngpcl) {
		this.vpa_ngpcl = vpa_ngpcl;
	}

	public Double getVpa_fwxl() {
		return vpa_fwxl;
	}

	public void setVpa_fwxl(Double vpa_fwxl) {
		this.vpa_fwxl = vpa_fwxl;
	}

	public Double getVpa_cgzhdf() {
		return vpa_cgzhdf;
	}

	public void setVpa_cgzhdf(Double vpa_cgzhdf) {
		this.vpa_cgzhdf = vpa_cgzhdf;
	}

	public Double getVpa_cgjcgkfqzdf() {
		return vpa_cgjcgkfqzdf;
	}

	public void setVpa_cgjcgkfqzdf(Double vpa_cgjcgkfqzdf) {
		this.vpa_cgjcgkfqzdf = vpa_cgjcgkfqzdf;
	}

	public Double getVpa_zjdf() {
		return vpa_zjdf;
	}

	public void setVpa_zjdf(Double vpa_zjdf) {
		this.vpa_zjdf = vpa_zjdf;
	}

	public String getVpa_gysqrdf() {
		return vpa_gysqrdf;
	}

	public void setVpa_gysqrdf(String vpa_gysqrdf) {
		this.vpa_gysqrdf = vpa_gysqrdf;
	}

	public String getVpa_brkyy() {
		return vpa_brkyy;
	}

	public void setVpa_brkyy(String vpa_brkyy) {
		this.vpa_brkyy = vpa_brkyy;
	}

	public String getVpa_zlpffj() {
		return vpa_zlpffj;
	}

	public void setVpa_zlpffj(String vpa_zlpffj) {
		this.vpa_zlpffj = vpa_zlpffj;
	}

	public String getVpa_jspffj() {
		return vpa_jspffj;
	}

	public void setVpa_jspffj(String vpa_jspffj) {
		this.vpa_jspffj = vpa_jspffj;
	}

	public String getVpa_cgpffj() {
		return vpa_cgpffj;
	}

	public void setVpa_cgpffj(String vpa_cgpffj) {
		this.vpa_cgpffj = vpa_cgpffj;
	}

	public Date getVpa_auditdate() {
		return vpa_auditdate;
	}

	public void setVpa_auditdate(Date vpa_auditdate) {
		this.vpa_auditdate = vpa_auditdate;
	}

	public String getVpa_auditor() {
		return vpa_auditor;
	}

	public void setVpa_auditor(String vpa_auditor) {
		this.vpa_auditor = vpa_auditor;
	}

	public String getVpa_jbxxfj() {
		return vpa_jbxxfj;
	}

	public void setVpa_jbxxfj(String vpa_jbxxfj) {
		this.vpa_jbxxfj = vpa_jbxxfj;
	}

	public String getVpa_purchasename() {
		return vpa_purchasename;
	}

	public void setVpa_purchasename(String vpa_purchasename) {
		this.vpa_purchasename = vpa_purchasename;
	}

	public String getVpa_sqename() {
		return vpa_sqename;
	}

	public void setVpa_sqename(String vpa_sqename) {
		this.vpa_sqename = vpa_sqename;
	}

	public String getVpa_ordername() {
		return vpa_ordername;
	}

	public void setVpa_ordername(String vpa_ordername) {
		this.vpa_ordername = vpa_ordername;
	}

	public Long getVe_uu() {
		return ve_uu;
	}

	public void setVe_uu(Long ve_uu) {
		this.ve_uu = ve_uu;
	}

	public String getVpa_grade() {
		return vpa_grade;
	}

	public void setVpa_grade(String vpa_grade) {
		this.vpa_grade = vpa_grade;
	}

	@Override
	public Object getKey() {
		return this.vpa_id;
	}

}