package com.uas.erp.schedular.b2b.task;

import com.uas.erp.schedular.b2b.domain.BarAcceptNotify;
import com.uas.erp.schedular.b2b.domain.BarAcceptNotifyDown;
import com.uas.erp.schedular.task.support.Method;
import com.uas.erp.schedular.task.support.Role;
import com.uas.erp.schedular.util.ContextHolder;
import com.uas.erp.schedular.task.support.TaskMapping;
import org.springframework.stereotype.Component;
import org.springframework.util.CollectionUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by Pro1 on 2017/7/26.
 */
@Component
@TaskMapping(title = "条码收料通知", role = Role.SELLER)
public class BarAcceptNotifyTask extends AbstractTask {

    @TaskMapping(title = "从平台下载客户下达到平台的BarSendNotify", fixedDelay = 60000, method = Method.DOWNLOAD)
    public void downloadBarSendNotify() {
        List<BarAcceptNotifyDown> barAcceptNotifyDowns = getForList("/erp/bar/sendnotify", BarAcceptNotifyDown.class);
        if (!CollectionUtils.isEmpty(barAcceptNotifyDowns)) {
            ContextHolder.setDataSize(barAcceptNotifyDowns.size());
            saveBarSendNotify(barAcceptNotifyDowns);
        }
    }

    /**
     * 保存BarSendNotify
     *
     * @param downs
     */
    public void saveBarSendNotify(List<BarAcceptNotifyDown> downs) {
        ContextHolder.setDataSize(downs.size());
        List<String> sqls = new ArrayList<>();
        StringBuffer b2bIdStr = new StringBuffer();// b2b_id
        StringBuffer idStr = new StringBuffer();
        for (BarAcceptNotifyDown barAcceptNotify : downs) {
            BarAcceptNotify barNotify = barAcceptNotify.convert();
            int count = jdbcTemplate.count("from acceptnotify where B2B_SS_ID = ?", barAcceptNotify.getBad_ssid());
            if (count > 0) {
                // 发货单已收料
                // barCount判断是否已经存在条码
                int barCount = jdbcTemplate.count("from barAcceptNotify where ban_anid =(select an_id from acceptnotify where B2B_SS_ID = ?)", barAcceptNotify.getBad_ssid());
                String[] fields2 = {"and_id", "and_detno", "and_yqty"};
                Object[] data = jdbcTemplate.queryForArray("select an_id,an_code from acceptnotify where B2B_SS_ID=?", barAcceptNotify.getBad_ssid());
                if (data != null && data.length == 2) {
                    barNotify.setBcn_anid(Long.parseLong(data[0].toString()));
                    barNotify.setBcn_ancode(data[1].toString());
                    Object[] data2 = jdbcTemplate.queryForArray("select and_id,and_detno,and_yqty from acceptnotifydetail where and_anid=? and and_detno=?", barNotify.getBcn_anid(), barAcceptNotify.getBad_sinumber());
                    if (data2 != null && data2.length == 3) {
                        barNotify.setBcn_andid(Long.parseLong(data2[0].toString()));
                        barNotify.setBcn_anddetno(Double.parseDouble(data2[1].toString()));
                    }
                    if (idStr.length() > 0) {
                        idStr.append(",");
                        b2bIdStr.append(",");
                    }
                    int sosid = jdbcTemplate.generate("Baracceptnotify_seq");
                    idStr.append(sosid);
                    if (data2 != null && data2.length == 3) {
                        if (Long.parseLong(data2[2].toString()) > 0) {
                        } else {
                            if (barCount > 0) {
                                String sql = "delete from package where pa_b2bid = "
                                        + "(select distinct ban_outboxid from baracceptnotify ban join acceptnotify an on ban.ban_anid=an.an_id where an.b2b_ss_id="
                                        + barAcceptNotify.getBad_ssid() + ")";
                                String sql2 = "delete from packagedetail where pd_paid ="
                                        + "(select distinct pd.pd_paid from packagedetail pd join package pa on pd.pd_paid=pa.pa_id where pa.pa_b2bid = "
                                        + "(select distinct ban_outboxid from baracceptnotify ban join acceptnotify an on ban.ban_anid=an.an_id where an.b2b_ss_id="
                                        + barAcceptNotify.getBad_ssid() + "))";
                                sqls.add(sql2);
                                sqls.add(sql);
                                sqls.add(barNotify.toDelete());
                            }
                            sqls.add(barNotify.toSqlOutSource(sosid));
                            b2bIdStr.append(barAcceptNotify.getBad_ssid());
                        }
                    }
                }
            }
        }
        jdbcTemplate.batchExecute(sqls);
        barSendNotifySuccess(b2bIdStr.toString());
    }

    /**
     * 成功保存后，修改平台的条码表为已下载
     *
     * @param idStr
     */
    private void barSendNotifySuccess(String idStr) {
        post("/erp/bar/sendnotify", dataWrap(idStr));
    }

}
