package com.uas.erp.schedular.b2b.task;

import com.uas.erp.schedular.b2b.domain.BarcodeSet;
import com.uas.erp.schedular.task.support.TaskMapping;
import com.uas.erp.schedular.util.ContextHolder;
import org.springframework.stereotype.Component;
import org.springframework.util.CollectionUtils;

import java.util.List;

/**
 * Created by Pro1 on 2017/8/2.
 */
@Component
@TaskMapping(title = "条码")
public class BarcodeSetTask extends AbstractTask{

    @TaskMapping(title = "上传条码产生规则表", fixedDelay = 300000)
    public void uploadBarcodeSet() {
        List<BarcodeSet> codeSets = jdbcTemplate.queryForBeanList("select * from( select * from BarcodeSet where bs_sendstatus='待上传' and bs_type in ('BATCH','PACK') and bs_status='已审核') where rownum<=200", BarcodeSet.class);
        if (!CollectionUtils.isEmpty(codeSets)) {
            ContextHolder.setDataSize(codeSets.size());
            new StatusBasedHandler<BarcodeSet>("BarcodeSet", "bs_id", "bs_sendstatus", "/erp/Barcode/codeSet", codeSets).run();
        }
    }

}
