package com.uas.erp.schedular.b2b.task;

import com.uas.erp.schedular.b2b.domain.MakeChange;
import com.uas.erp.schedular.b2b.domain.MakeChangeDetail;
import com.uas.erp.schedular.task.support.Role;
import com.uas.erp.schedular.task.support.TaskMapping;
import com.uas.erp.schedular.util.CollectionUtil;
import com.uas.erp.schedular.util.ContextHolder;
import org.springframework.stereotype.Component;
import org.springframework.util.CollectionUtils;

import java.util.List;

/**
 * Created by Pro1 on 2017/8/2.
 */
@Component
@TaskMapping(title = "委外变更", role = Role.BUYER)
public class MakeChangeTask extends AbstractTask {

    @TaskMapping(title = "上传委外变更单", fixedDelay = 60000)
    public void uploadMakeChange() {
        List<MakeChange> changes = getMakeChangeUpload();
        if (!CollectionUtils.isEmpty(changes)) {
            ContextHolder.setDataSize(changes.size());
            final String idStr = CollectionUtil.getKeyString(changes);
            new StatusBasedHandler<MakeChange>("makechange", "mc_id", "mc_sendstatus", "/erp/make/change", changes).run();
        }
    }

    /**
     * 获取需要上传的委外变更单
     *
     * @return
     */
    private List<MakeChange> getMakeChangeUpload() {
        List<MakeChange> makeChanges = jdbcTemplate.queryForBeanList("select * from (select mc.* from makechange mc where MC_SENDSTATUS='待上传' and exists (select 1 from makechangedetail mcd left join make m on mcd.md_makecode=m.ma_code where ma_sendstatus='已上传')) where rownum<=100",
                MakeChange.class);
        for (MakeChange makeChange : makeChanges) {
            List<MakeChangeDetail> changeDetails = jdbcTemplate.queryForBeanList(
                    "select * from makechangedetail left join make on md_makecode=ma_code where md_mcid=? and ma_sendstatus='已上传'",
                    MakeChangeDetail.class, makeChange.getMc_id());
            makeChange.setChangeDetails(changeDetails);
        }
        return makeChanges;
    }

}
