package com.uas.erp.schedular.b2b.task;

import com.uas.erp.schedular.b2b.domain.Prod;
import com.uas.erp.schedular.task.support.Role;
import com.uas.erp.schedular.task.support.TaskMapping;
import com.uas.erp.schedular.util.CollectionUtil;
import com.uas.erp.schedular.util.ContextHolder;
import org.springframework.stereotype.Component;
import org.springframework.util.CollectionUtils;

import java.util.ArrayList;
import java.util.List;


/**
 * 获取平台未下载的物料信息
 *
 * Created by hejq on 2018-06-19.
 */
@Component
@TaskMapping(title = "物料检测", role = Role.PLAIN)
public class ProdCheckTask extends AbstractTask {

    /**
     * B2B订单发现物料不存在会记录下来，现在上传数据方法已经更新，新增任务去获取未存在的物料数据
     */
    @TaskMapping(title = "获取未下载物料", fixedDelay = 60000)
    public void checkProduct() {
        List<Prod> prods = getForList("/erp/product/notExistProds", Prod.class);
        if (!CollectionUtils.isEmpty(prods)) {
            ContextHolder.setDataSize(prods.size());
            List<String> sqlList = new ArrayList<String>();
            for (Prod prod : prods) {
                sqlList.add("update product set pr_sendStatus = '待上传' where pr_code = '" + prod.getPr_code() + "'");
            }
            jdbcTemplate.batchExecute(sqlList);
            String idStr = CollectionUtil.getKeyString(prods, new CollectionUtil.KeyIterator<Prod>() {
                @Override
                public Object getKey(Prod prod) {
                    return prod.getB2b_id();
                }
            });
            post("/erp/product/notExistProds/back", dataWrap(idStr));
        }
    }
}
