package com.uas.erp.schedular.b2b.task;

import com.uas.erp.schedular.b2b.domain.*;
import com.uas.erp.schedular.task.support.Role;
import com.uas.erp.schedular.task.support.TaskMapping;
import com.uas.erp.schedular.util.ContextHolder;
import org.springframework.stereotype.Component;
import org.springframework.util.CollectionUtils;
import org.springframework.util.StringUtils;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by Pro1 on 2017/8/3.
 */
@Component
@TaskMapping(title = "MRB", role = Role.BUYER)
public class PurchaseMRBTask extends AbstractTask {

    @TaskMapping(title = "上传MRB", fixedDelay = 60000)
    public void uploadMRB() {
        List<PurchaseQuaMRB> purchaseMRBs = getMRBUpload();
        if (!CollectionUtils.isEmpty(purchaseMRBs)) {
            ContextHolder.setDataSize(purchaseMRBs.size());
            purchaseMRBs = postForList("/erp/purchase/MRB", PurchaseQuaMRB.class, dataWrap(purchaseMRBs));
            List<String> sqlList = new ArrayList<>();
            for (PurchaseQuaMRB mrb : purchaseMRBs) {
                if (null != mrb.getMr_b2bid()) {
                    sqlList.add(" update qua_mrb set mr_sendStatus = '已上传', mr_b2bid = " + mrb.getMr_b2bid() + " where mr_id = " + mrb.getMr_id());
                }
            }
            if (!CollectionUtils.isEmpty(sqlList)) {
                jdbcTemplate.batchExecute(sqlList);
            }
        }
    }

    /**
     * 获取需要上传的MRB
     *
     * @return
     */
    public List<PurchaseQuaMRB> getMRBUpload() {
        List<PurchaseQuaMRB> purchaseMRBs = jdbcTemplate.queryForBeanList(
                "select qua_mrb.*, vendor.ve_uu mr_venduu, qua_mrb.mr_presult mr_result from qua_mrb "
                        + " left join vendor on qua_mrb.mr_vendcode = vendor.ve_code where mr_sendstatus = '待上传' "
                        + " and mr_status = '已审核' and mr_qctype = '采购检验单' and coalesce(ve_uu, '0') <> '0' and nvl(ve_b2benable,0)<>0 ",
                PurchaseQuaMRB.class);
        for (PurchaseQuaMRB purchaseMRB : purchaseMRBs) {
            List<PurchaseQuaMRBCheckItem> checkItems = jdbcTemplate.queryForBeanList("select * from qua_mrbdet where md_mrid = ? ",
                    PurchaseQuaMRBCheckItem.class, purchaseMRB.getMr_id());
            purchaseMRB.setCheckItems(checkItems);
            List<PurchaseQuaMRBProjectItem> projectItems = jdbcTemplate.queryForBeanList(
                    "select * from qua_mrbdetail where mrd_mrid = ? ", PurchaseQuaMRBProjectItem.class, purchaseMRB.getMr_id());
            purchaseMRB.setProjectItems(projectItems);
            // 附件信息
            if (StringUtils.hasText(purchaseMRB.getMr_attach())) {
                purchaseMRB.setAttaches(getAttachs(purchaseMRB.getMr_attach().split(";")));
            }
        }
        return purchaseMRBs;
    }

}
