package com.uas.erp.schedular.core;

/**
 * 系统业务单据状态
 * 
 * @author yingp
 * 
 */
public enum Status {

	/**
	 * 在录入
	 */
	ENTERING("在录入"),
	/**
	 * 已提交
	 */
	COMMITED("已提交"),
	/**
	 * 已审核
	 */
	AUDITED("已审核"),
	/**
	 * 已冻结
	 */
	FREEZE("已冻结"),
	/**
	 * 已结案
	 */
	FINISH("已结案"),
	/**
	 * 已作废
	 */
	NULLIFIED("已作废"),
	/**
	 * 已过账
	 */
	POSTED("已过账"),
	/**
	 * 未记账
	 */
	UNPOST("未记账"),
	/**
	 * 已打印
	 */
	PRINTED("已打印"),
	/**
	 * 未打印
	 */
	UNPRINT("未打印"),
	/**
	 * 已回复
	 */
	REPLYED("已回复"),
	/**
	 * 未回复
	 */
	UNREPLY("未回复"),
	/**
	 * 未完工
	 */
	UNCOMPLET("未完工"),
	/**
	 * 挂起
	 */
	HUNG("挂起"),
	/**
	 * 已禁用
	 */
	DISABLE("已禁用"),
	/**
	 * 已批准
	 */
	APPROVE("已批准"),
	/**
	 * 未批准
	 */
	UNAPPROVED("未批准"),
	/**
	 * 已入库
	 */
	TURNIN("已入库"),
	/**
	 * 已出库
	 */
	TURNOUT("已出库"),
	/**
	 * 部分转采购
	 */
	PART2PU("部分转采购"),
	/**
	 * 已转采购
	 */
	TURNPURC("已转采购"),
	/**
	 * 已转通知单
	 */
	TURNSN("已转通知单"),
	/**
	 * 已转收料
	 */
	TURNVA("已转收料"),
	/**
	 * 待确认
	 */
	TO_CONFIRM("待确认"),
	/**
	 * 已确认
	 */
	CONFIRMED("已确认"),
	/**
	 * 空状态
	 */
	NONE("");

	private final String code;
	private final String display;

	private Status(String display) {
		this.code = this.toString();
		this.display = display;
	}

	/**
	 * @return 状态的编码
	 */
	public String code() {
		if (this == NONE)
			return "";
		return this.code;
	}

	public String display() {
		return this.display;
	}

}
