package com.uas.erp.schedular.database;

import com.uas.erp.schedular.util.ContextHolder;

/**
 * Created by Pro1 on 2017/7/27.
 */
public class Executable {

    // 数据源名称
    private String qualifier;
    // 可执行语句
    private String[] execs;
    // 参数
    private Object[] args;
    // 是否查询
    private boolean isQuery;
    // 是否call procedure
    private boolean isCall;
    // 返回字段
    private String[] returnFields;

    public String getQualifier() {
        return qualifier;
    }

    public void setQualifier(String qualifier) {
        this.qualifier = qualifier;
    }

    public String[] getExecs() {
        return execs;
    }

    public void setExecs(String[] execs) {
        this.execs = execs;
    }

    public Object[] getArgs() {
        return args;
    }

    public void setArgs(Object[] args) {
        this.args = args;
    }

    public boolean isQuery() {
        return isQuery;
    }

    public void setQuery(boolean query) {
        isQuery = query;
    }

    public String[] getReturnFields() {
        return returnFields;
    }

    public void setReturnFields(String[] returnFields) {
        this.returnFields = returnFields;
    }

    public boolean isCall() {
        return isCall;
    }

    public void setCall(boolean call) {
        isCall = call;
    }

    public Executable() {
        this.qualifier = ContextHolder.getMaster().getMa_user().toUpperCase();
    }

    public static Executable query(String exec, Object[] args) {
        Executable executable = new Executable();
        executable.setQuery(true);
        executable.setArgs(args);
        executable.setExecs(new String[]{ exec });
        return executable;
    }

    public static Executable query(String exec, String[] returnFields, Object[] args) {
        Executable executable = query(exec, args);
        executable.setReturnFields(returnFields);
        return executable;
    }

    public static Executable call(String exec, Object[] args) {
        Executable executable = new Executable();
        executable.setCall(true);
        executable.setArgs(args);
        executable.setExecs(new String[]{ exec });
        return executable;
    }

    public static Executable call(String exec, String[] returnFields, Object[] args) {
        Executable executable = call(exec, args);
        executable.setReturnFields(returnFields);
        return executable;
    }

    public static Executable execute(String exec, Object[] args) {
        Executable executable = new Executable();
        executable.setArgs(args);
        executable.setExecs(new String[]{ exec });
        return executable;
    }

    public static Executable execute(String... execs) {
        Executable executable = new Executable();
        executable.setExecs(execs);
        return executable;
    }
}
