package com.uas.erp.schedular.diymall.domain;

import com.uas.erp.schedular.util.DateUtil;
import com.uas.erp.schedular.util.NumberUtil;
import com.uas.erp.schedular.util.StringUtil;

import java.util.Date;
import java.util.Set;

/**
 * 定制商城订单主表数据
 * 
 * @author huangct
 * @time 创建时间：2017年12月25日
 */
public class DiymallOrder {
	private Long id;

	//订单号
	private String code;//SA_CODE

	//付款方式
	private Integer payment;

	//用户id
	private Integer userId;

	//订单状态
	private Integer status;

	//删除   管理后台能否查询的到，类似可用状态（展示状态） 0隐藏  1展示
	private Integer display;

	//收件人
	private String takeName;

	//收件人电话 手机号
	private String takePhone;

	//收件人邮政编码（展示在收件地址中）
	private String takePostCode;

	//收件地区
	private Integer takeAreaId;

	//地区名称 收件人地区（省市区）
	private String takeAreaMsg;

	//详细地址 收件人地址（街道之类）
	private String takeAddress;

	//收款账号
	private String toBankNumber;

	//收款人
	private String toBankName;

	//收款银行
	private String toBankType;

	//收款开户行
	private String toBbankAddress;

	//付款人
	private String fromBankNumber;

	//付款账号
	private String fromBankName;

	//备注
	private String remark;

	//订单备注（管理员备注）
	private String adminRemark;

	//发票抬头 发票信息  名
	private String invoiceName;

	//发票税号 发票信息  号
	private String invoiceNumber;

	//运费表主键id
	private Integer freightId;

	//运费 运费价格
	private Double freightPrice;

	//小计
	private Double subtotal;

	//总计
	private Double grandTotal;

	//运单号
	private String trackingCode;

	//承运公司
	private String trackingCompany;

	//承运公司编号
	private String trackingKdnCode;

	//运单状态  都为0了
	private Integer trackingStatus;

	//运单最新更新时间
	private Date trackingUpdateDate;

	//下单时间(创建时间)
	private Date createDate;

	//付款时间
	private Date paymentDate;

	//发货时间
	private Date trackingDate;

	//收货时间
	private Date receivedDate;

	//完成时间
	private Date finishDate;

	//申请退款时间
	private Date refundDate;

	private Integer synData;

	private Set<DiymallOrderItem> diymallOrderItems;

	public Long getId() {
		return id;
	}

	public void setId(Long id) {
		this.id = id;
	}

	public String getCode() {
		return code;
	}

	public void setCode(String code) {
		this.code = code;
	}

	public Integer getPayment() {
		return payment;
	}

	public void setPayment(Integer payment) {
		this.payment = payment;
	}

	public Integer getUserId() {
		return userId;
	}

	public void setUserId(Integer userId) {
		this.userId = userId;
	}

	public Integer getStatus() {
		return status;
	}

	public void setStatus(Integer status) {
		this.status = status;
	}

	public Integer getDisplay() {
		return display;
	}

	public void setDisplay(Integer display) {
		this.display = display;
	}

	public String getTakeName() {
		return takeName;
	}

	public void setTakeName(String takeName) {
		this.takeName = takeName;
	}

	public String getTakePhone() {
		return takePhone;
	}

	public void setTakePhone(String takePhone) {
		this.takePhone = takePhone;
	}

	public String getTakePostCode() {
		return takePostCode;
	}

	public void setTakePostCode(String takePostCode) {
		this.takePostCode = takePostCode;
	}

	public Integer getTakeAreaId() {
		return takeAreaId;
	}

	public void setTakeAreaId(Integer takeAreaId) {
		this.takeAreaId = takeAreaId;
	}

	public String getTakeAreaMsg() {
		return takeAreaMsg;
	}

	public void setTakeAreaMsg(String takeAreaMsg) {
		this.takeAreaMsg = takeAreaMsg;
	}

	public String getTakeAddress() {
		return takeAddress;
	}

	public void setTakeAddress(String takeAddress) {
		this.takeAddress = takeAddress;
	}

	public String getToBankNumber() {
		return toBankNumber;
	}

	public void setToBankNumber(String toBankNumber) {
		this.toBankNumber = toBankNumber;
	}

	public String getToBankName() {
		return toBankName;
	}

	public void setToBankName(String toBankName) {
		this.toBankName = toBankName;
	}

	public String getToBankType() {
		return toBankType;
	}

	public void setToBankType(String toBankType) {
		this.toBankType = toBankType;
	}

	public String getToBbankAddress() {
		return toBbankAddress;
	}

	public void setToBbankAddress(String toBbankAddress) {
		this.toBbankAddress = toBbankAddress;
	}

	public String getFromBankNumber() {
		return fromBankNumber;
	}

	public void setFromBankNumber(String fromBankNumber) {
		this.fromBankNumber = fromBankNumber;
	}

	public String getFromBankName() {
		return fromBankName;
	}

	public void setFromBankName(String fromBankName) {
		this.fromBankName = fromBankName;
	}

	public String getRemark() {
		return remark;
	}

	public void setRemark(String remark) {
		this.remark = remark;
	}

	public String getAdminRemark() {
		return adminRemark;
	}

	public void setAdminRemark(String adminRemark) {
		this.adminRemark = adminRemark;
	}

	public String getInvoiceName() {
		return invoiceName;
	}

	public void setInvoiceName(String invoiceName) {
		this.invoiceName = invoiceName;
	}

	public String getInvoiceNumber() {
		return invoiceNumber;
	}

	public void setInvoiceNumber(String invoiceNumber) {
		this.invoiceNumber = invoiceNumber;
	}

	public Integer getFreightId() {
		return freightId;
	}

	public void setFreightId(Integer freightId) {
		this.freightId = freightId;
	}

	public Double getFreightPrice() {
		return freightPrice;
	}

	public void setFreightPrice(Double freightPrice) {
		this.freightPrice = freightPrice;
	}

	public Double getSubtotal() {
		return subtotal;
	}

	public void setSubtotal(Double subtotal) {
		this.subtotal = subtotal;
	}

	public Double getGrandTotal() {
		return grandTotal;
	}

	public void setGrandTotal(Double grandTotal) {
		this.grandTotal = grandTotal;
	}

	public String getTrackingCode() {
		return trackingCode;
	}

	public void setTrackingCode(String trackingCode) {
		this.trackingCode = trackingCode;
	}

	public String getTrackingCompany() {
		return trackingCompany;
	}

	public void setTrackingCompany(String trackingCompany) {
		this.trackingCompany = trackingCompany;
	}

	public String getTrackingKdnCode() {
		return trackingKdnCode;
	}

	public void setTrackingKdnCode(String trackingKdnCode) {
		this.trackingKdnCode = trackingKdnCode;
	}

	public Integer getTrackingStatus() {
		return trackingStatus;
	}

	public void setTrackingStatus(Integer trackingStatus) {
		this.trackingStatus = trackingStatus;
	}

	public Date getTrackingUpdateDate() {
		return trackingUpdateDate;
	}

	public void setTrackingUpdateDate(Date trackingUpdateDate) {
		this.trackingUpdateDate = trackingUpdateDate;
	}

	public Date getCreateDate() {
		return createDate;
	}

	public void setCreateDate(Date createDate) {
		this.createDate = createDate;
	}

	public Date getPaymentDate() {
		return paymentDate;
	}

	public void setPaymentDate(Date paymentDate) {
		this.paymentDate = paymentDate;
	}

	public Date getTrackingDate() {
		return trackingDate;
	}

	public void setTrackingDate(Date trackingDate) {
		this.trackingDate = trackingDate;
	}

	public Date getReceivedDate() {
		return receivedDate;
	}

	public void setReceivedDate(Date receivedDate) {
		this.receivedDate = receivedDate;
	}

	public Date getFinishDate() {
		return finishDate;
	}

	public void setFinishDate(Date finishDate) {
		this.finishDate = finishDate;
	}

	public Date getRefundDate() {
		return refundDate;
	}

	public void setRefundDate(Date refundDate) {
		this.refundDate = refundDate;
	}

	public Integer getSynData() {
		return synData;
	}

	public void setSynData(Integer synData) {
		this.synData = synData;
	}

	public Set<DiymallOrderItem> getDiymallOrderItems() {
		return diymallOrderItems;
	}

	public void setDiymallOrderItems(Set<DiymallOrderItem> diymallOrderItems) {
		this.diymallOrderItems = diymallOrderItems;
	}

	public String toSqlString(int primaryKey) {
		return "INSERT INTO SALE (SA_ID,SA_CODE,SA_TOPLACE,SA_DATE,SA_TOTAL,SA_FARE,SA_REMARK,SA_SHCUSTNAME) VALUES ("
				+ primaryKey
				+ ",'"
				+ StringUtil.nvl(code, "")
				+ "','"
				+ StringUtil.nvl(takeAreaMsg, "") + StringUtil.nvl(takeAddress, "")
				+ "',"
				+ DateUtil.parseDateToOracleString(null, createDate)
				+ ","
				+ NumberUtil.nvl(grandTotal, 0)
				+ ", "
				+ NumberUtil.nvl(freightPrice, 0)
				+ ",'"
				+ StringUtil.nvl(remark, "")
				+ "','"
				+ StringUtil.nvl(takeName, "")


//				+ "', "
//				+ StringUtil.nvl(payment, "")
//				+ ",'"
//				+ StringUtil.nvl(userId, "")
//				+ ",'"
//				+ StringUtil.nvl(status, "")
//				+ "', "
//				+ StringUtil.nvl(display, "")
//				+ ",'"
//				+ StringUtil.nvl(takePhone, "")
//				+ "', "
//				+ StringUtil.nvl(takePostCode, "")
//				+ ",'"
//				+ StringUtil.nvl(takeAreaId, "")
//				+ ",'"
//				+ StringUtil.nvl(toBankNumber, "")
//				+ ",'"
//				+ StringUtil.nvl(toBankName, "")
//				+ "', "
//				+ StringUtil.nvl(toBankType, "")
//				+ ",'"
//				+ StringUtil.nvl(toBbankAddress, "")
//				+ ",'"
//				+ StringUtil.nvl(fromBankNumber, "")
//				+ "', "
//				+ StringUtil.nvl(fromBankName, "")
//				+ ",'"
//				+ StringUtil.nvl(adminRemark, "")
//				+ "', "
//				+ StringUtil.nvl(invoiceName, "")
//				+ ",'"
//				+ StringUtil.nvl(invoiceNumber, "")
//				+ ",'"
//				+ StringUtil.nvl(freightId, "")
//				+ ",'"
//				+ StringUtil.nvl(subtotal, "")
//				+ "', "
//				+ StringUtil.nvl(trackingCode, "")
//				+ ",'"
//				+ StringUtil.nvl(trackingCompany, "")
//				+ ",'"
//				+ StringUtil.nvl(trackingKdnCode, "")
//				+ "', "
//				+ StringUtil.nvl(trackingStatus, "")
//				+ ",'"
//				+ StringUtil.nvl(trackingUpdateDate, "")
//				+ "', "
//				+ StringUtil.nvl(paymentDate, "")
//				+ ",'"
//				+ StringUtil.nvl(trackingDate, "")
//				+ ",'"
//				+ StringUtil.nvl(receivedDate, "")
//				+ "', "
//				+ StringUtil.nvl(finishDate, "")
//				+ ",'"
//				+ StringUtil.nvl(refundDate, "")

				+ "')";
	}
}
