package com.uas.erp.schedular.diymall.domain;

import java.util.List;

/**
 * 订单
 * @author zhaoy
 * @create 2019-05-08 16:39
 */
public class Order {

    String code; // 编号
    Integer enuu; // 买家企业uu
    Integer uu; // 买家uu
    Integer sellerEnuu; //enuu
    String buyerName; //买家姓名
    String buyerEnName; //买家企业姓名
    String buyerMobile; //买家电话
    String buyerEmail;//   买家email
    String sellerName; //  卖家企业名
    String sellerTelephone;// 卖家固定电话
    String sellerBusinesscode;// 卖家营业执照号
    String sellerAdmName;//  卖家管理员姓名
    Integer sellerAdmUu;//  卖家管理员uu
    String sellerAdmEmail;// 卖家管理员邮箱
    String sellerAdmMobile; //卖家管理员手机
    Integer status;//  状态（141000 ：初始状态，141010：待支付，141020：待收款，141030：待发货，141040：待收货，141050：交易成功, 141090: 已取消）
    double sumMoney;// 总金额
    String currency; //币别
    Integer invoiceStatus;// 开票状态
    String payFileUrl; //订单支付凭证文件链接
    String remark;//  备注
    String createdTime;// 订单创建时间
    String paidTime; // 订单支付时间
    String ensurePayTime; // 确认收款时间
    String deliverTime; // 发货时间
    String receiveTime; // 收货时间
    Integer orderType; //141100 ：产品订单， 141110： 报价订单
    String settlementTime; //账期
    String reconciliateTime; //对账时间
    List<OrderProduct> orderProduct; // 订单产品快照列表
    OrderDeliveryAddr orderDeliveryAddr; // 订单收货地址
    OrderInvoice orderInvoice; // 订单发票
    OrderInvoiceAddr orderInvoiceAddr; // 订单发票寄送地址
    OrderExpress orderExpress; // 订单物流信息
    List<OrderTimeAxis> orderTimeAxis; //订单时间轴
    SellerDueBank sellerDueBank; // 商家收款信息
    private Integer erpEnuu;        //erp-客户或供应商enuu

    public Integer getErpEnuu() {
        return erpEnuu;
    }

    public void setErpEnuu(Integer erpEnuu) {
        this.erpEnuu = erpEnuu;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public Integer getEnuu() {
        return enuu;
    }

    public void setEnuu(Integer enuu) {
        this.enuu = enuu;
    }

    public Integer getUu() {
        return uu;
    }

    public void setUu(Integer uu) {
        this.uu = uu;
    }

    public Integer getSellerEnuu() {
        return sellerEnuu;
    }

    public void setSellerEnuu(Integer sellerEnuu) {
        this.sellerEnuu = sellerEnuu;
    }

    public String getBuyerName() {
        return buyerName;
    }

    public void setBuyerName(String buyerName) {
        this.buyerName = buyerName;
    }

    public String getBuyerEnName() {
        return buyerEnName;
    }

    public void setBuyerEnName(String buyerEnName) {
        this.buyerEnName = buyerEnName;
    }

    public String getBuyerMobile() {
        return buyerMobile;
    }

    public void setBuyerMobile(String buyerMobile) {
        this.buyerMobile = buyerMobile;
    }

    public String getBuyerEmail() {
        return buyerEmail;
    }

    public void setBuyerEmail(String buyerEmail) {
        this.buyerEmail = buyerEmail;
    }

    public String getSellerName() {
        return sellerName;
    }

    public void setSellerName(String sellerName) {
        this.sellerName = sellerName;
    }

    public String getSellerTelephone() {
        return sellerTelephone;
    }

    public void setSellerTelephone(String sellerTelephone) {
        this.sellerTelephone = sellerTelephone;
    }

    public String getSellerBusinesscode() {
        return sellerBusinesscode;
    }

    public void setSellerBusinesscode(String sellerBusinesscode) {
        this.sellerBusinesscode = sellerBusinesscode;
    }

    public String getSellerAdmName() {
        return sellerAdmName;
    }

    public void setSellerAdmName(String sellerAdmName) {
        this.sellerAdmName = sellerAdmName;
    }

    public Integer getSellerAdmUu() {
        return sellerAdmUu;
    }

    public void setSellerAdmUu(Integer sellerAdmUu) {
        this.sellerAdmUu = sellerAdmUu;
    }

    public String getSellerAdmEmail() {
        return sellerAdmEmail;
    }

    public void setSellerAdmEmail(String sellerAdmEmail) {
        this.sellerAdmEmail = sellerAdmEmail;
    }

    public String getSellerAdmMobile() {
        return sellerAdmMobile;
    }

    public void setSellerAdmMobile(String sellerAdmMobile) {
        this.sellerAdmMobile = sellerAdmMobile;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public double getSumMoney() {
        return sumMoney;
    }

    public void setSumMoney(double sumMoney) {
        this.sumMoney = sumMoney;
    }

    public String getCurrency() {
        return currency;
    }

    public void setCurrency(String currency) {
        this.currency = currency;
    }

    public Integer getInvoiceStatus() {
        return invoiceStatus;
    }

    public void setInvoiceStatus(Integer invoiceStatus) {
        this.invoiceStatus = invoiceStatus;
    }

    public String getPayFileUrl() {
        return payFileUrl;
    }

    public void setPayFileUrl(String payFileUrl) {
        this.payFileUrl = payFileUrl;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public String getCreatedTime() {
        return createdTime;
    }

    public void setCreatedTime(String createdTime) {
        this.createdTime = createdTime;
    }

    public String getPaidTime() {
        return paidTime;
    }

    public void setPaidTime(String paidTime) {
        this.paidTime = paidTime;
    }

    public String getEnsurePayTime() {
        return ensurePayTime;
    }

    public void setEnsurePayTime(String ensurePayTime) {
        this.ensurePayTime = ensurePayTime;
    }

    public String getDeliverTime() {
        return deliverTime;
    }

    public void setDeliverTime(String deliverTime) {
        this.deliverTime = deliverTime;
    }

    public String getReceiveTime() {
        return receiveTime;
    }

    public void setReceiveTime(String receiveTime) {
        this.receiveTime = receiveTime;
    }

    public Integer getOrderType() {
        return orderType;
    }

    public void setOrderType(Integer orderType) {
        this.orderType = orderType;
    }

    public String getSettlementTime() {
        return settlementTime;
    }

    public void setSettlementTime(String settlementTime) {
        this.settlementTime = settlementTime;
    }

    public String getReconciliateTime() {
        return reconciliateTime;
    }

    public void setReconciliateTime(String reconciliateTime) {
        this.reconciliateTime = reconciliateTime;
    }

    public List<OrderProduct> getOrderProduct() {
        return orderProduct;
    }

    public void setOrderProduct(List<OrderProduct> orderProduct) {
        this.orderProduct = orderProduct;
    }

    public OrderDeliveryAddr getOrderDeliveryAddr() {
        return orderDeliveryAddr;
    }

    public void setOrderDeliveryAddr(OrderDeliveryAddr orderDeliveryAddr) {
        this.orderDeliveryAddr = orderDeliveryAddr;
    }

    public OrderInvoice getOrderInvoice() {
        return orderInvoice;
    }

    public void setOrderInvoice(OrderInvoice orderInvoice) {
        this.orderInvoice = orderInvoice;
    }

    public OrderInvoiceAddr getOrderInvoiceAddr() {
        return orderInvoiceAddr;
    }

    public void setOrderInvoiceAddr(OrderInvoiceAddr orderInvoiceAddr) {
        this.orderInvoiceAddr = orderInvoiceAddr;
    }

    public OrderExpress getOrderExpress() {
        return orderExpress;
    }

    public void setOrderExpress(OrderExpress orderExpress) {
        this.orderExpress = orderExpress;
    }

    public List<OrderTimeAxis> getOrderTimeAxis() {
        return orderTimeAxis;
    }

    public void setOrderTimeAxis(List<OrderTimeAxis> orderTimeAxis) {
        this.orderTimeAxis = orderTimeAxis;
    }

    public SellerDueBank getSellerDueBank() {
        return sellerDueBank;
    }

    public void setSellerDueBank(SellerDueBank sellerDueBank) {
        this.sellerDueBank = sellerDueBank;
    }
}
