package com.uas.erp.schedular.entity;

import org.springframework.util.Assert;
import org.springframework.util.StringUtils;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Transient;

/**
 * Created by Pro1 on 2017/7/26.
 */
@Entity
public class Setting {

    @Id
    private String key;

    private String description;

    @Column(name = "value_")
    private String value;

    /**
     * 是否需要用代码配置重置数据库配置，默认：否 <br/>
     * 可以通过配置setting.json中的选项配置修改
     */
    @Transient
    private boolean resetDefault = false;

    public Setting() {
    }

    public Setting(String key, String value) {
        this(null, key, null, value);
    }

    public Setting(String key, String description, String value) {
        this(null, key, description, value);
    }

    public Setting(String group, String key, String description, String value) {
        Assert.notNull(key);
        this.key = key;
        this.description = StringUtils.isEmpty(description) ? key : description;
        this.value = value;
    }

    public String getKey() {
        return key;
    }

    public void setKey(String key) {
        this.key = key;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getValue() {
        return value;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public boolean isResetDefault() {
        return resetDefault;
    }

    public void setResetDefault(boolean resetDefault) {
        this.resetDefault = resetDefault;
    }
}
