package com.uas.erp.schedular.init;

import com.alibaba.fastjson.JSON;
import com.uas.erp.schedular.entity.Setting;
import com.uas.erp.schedular.service.SettingService;
import com.uas.erp.schedular.util.StringUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;
import org.springframework.util.StringUtils;

import java.util.List;

/**
 * Created by Pro1 on 2017/7/28.
 */
@Component
public class DefaultInitializer implements CommandLineRunner {

    @Autowired
    private SettingService settingService;

    @Override
    public void run(String... strings) throws Exception {
        // 默认数据
        String settingsStr = StringUtil.copyResource("init/setting.json");
        if (!StringUtils.isEmpty(settingsStr)) {
            List<Setting> settings = JSON.parseArray(settingsStr, Setting.class);
            for(Setting setting : settings) {
                Setting oldOne = settingService.findOne(setting.getKey());
                if (null == oldOne) {
                    settingService.save(setting);
                } else {
                    // 需要用代码配置重置数据库配置，修改数据库配置内容
                    if (setting.isResetDefault()) {
                        oldOne.setValue(setting.getValue());
                        settingService.save(oldOne);
                    }
                }
                // 不修改已设置项
            }
        }
    }
}
