package com.uas.erp.schedular.mall.domain;

import com.uas.erp.schedular.publicinquiry.domain.Enterprise;

import java.util.List;

/**
 * 产品信息
 * @author zhaoy
 * @create 2019-05-07 17:52
 */
public class Product {

    String code; // 产品编号
    String model; // 型号
    String brand; // 品牌
    String spec; // 规格
    Integer collectStatus; // 收藏状态（134010：已收藏、134020：未收藏）
    Integer status; // 状态（131010.已下架，131020.已上架）
    String packing; // 包装方式
    Integer mpq; // 最小包装数量
    Integer moq; // 最小起订量
    Integer reserve; // 库存数量
    Integer frozenQty; // 冻结库存数量
    boolean detachable; // 是否可拆卖（可拆卖:true，不可拆卖:false）
    List<LadderOffer> ladderOffer; // 阶梯价格
    String unit; // 单位
    String currency; // 币别
    Integer minDelivery; // 最小交期
    Integer maxDelivery; // 最大交期
    boolean deleted; // 是否删除
    Enterprise enterprise; // 企业信息
    Integer buyAble; // 可购买状态（可购买:132010，库存不足:132011，信息不足:132012）
    Integer perAmount; // 每次购买变更数量
    double sum; // 小计金额
    Integer availableQty; // 剩余库存
    Integer sampleStatus; // 样品状态（134040：有样品、134041：无样品）
    String hlModel; // 高亮关键词型号
    Integer enuu; // 企业uu
    String materialCode; // 物料编号

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getModel() {
        return model;
    }

    public void setModel(String model) {
        this.model = model;
    }

    public String getBrand() {
        return brand;
    }

    public void setBrand(String brand) {
        this.brand = brand;
    }

    public String getSpec() {
        return spec;
    }

    public void setSpec(String spec) {
        this.spec = spec;
    }

    public Integer getCollectStatus() {
        return collectStatus;
    }

    public void setCollectStatus(Integer collectStatus) {
        this.collectStatus = collectStatus;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public String getPacking() {
        return packing;
    }

    public void setPacking(String packing) {
        this.packing = packing;
    }

    public Integer getMpq() {
        return mpq;
    }

    public void setMpq(Integer mpq) {
        this.mpq = mpq;
    }

    public Integer getMoq() {
        return moq;
    }

    public void setMoq(Integer moq) {
        this.moq = moq;
    }

    public Integer getReserve() {
        return reserve;
    }

    public void setReserve(Integer reserve) {
        this.reserve = reserve;
    }

    public Integer getFrozenQty() {
        return frozenQty;
    }

    public void setFrozenQty(Integer frozenQty) {
        this.frozenQty = frozenQty;
    }

    public boolean isDetachable() {
        return detachable;
    }

    public void setDetachable(boolean detachable) {
        this.detachable = detachable;
    }

    public List<LadderOffer> getLadderOffer() {
        return ladderOffer;
    }

    public void setLadderOffer(List<LadderOffer> ladderOffer) {
        this.ladderOffer = ladderOffer;
    }

    public String getUnit() {
        return unit;
    }

    public void setUnit(String unit) {
        this.unit = unit;
    }

    public String getCurrency() {
        return currency;
    }

    public void setCurrency(String currency) {
        this.currency = currency;
    }

    public Integer getMinDelivery() {
        return minDelivery;
    }

    public void setMinDelivery(Integer minDelivery) {
        this.minDelivery = minDelivery;
    }

    public Integer getMaxDelivery() {
        return maxDelivery;
    }

    public void setMaxDelivery(Integer maxDelivery) {
        this.maxDelivery = maxDelivery;
    }

    public boolean isDeleted() {
        return deleted;
    }

    public void setDeleted(boolean deleted) {
        this.deleted = deleted;
    }

    public Enterprise getEnterprise() {
        return enterprise;
    }

    public void setEnterprise(Enterprise enterprise) {
        this.enterprise = enterprise;
    }

    public Integer getBuyAble() {
        return buyAble;
    }

    public void setBuyAble(Integer buyAble) {
        this.buyAble = buyAble;
    }

    public Integer getPerAmount() {
        return perAmount;
    }

    public void setPerAmount(Integer perAmount) {
        this.perAmount = perAmount;
    }

    public double getSum() {
        return sum;
    }

    public void setSum(double sum) {
        this.sum = sum;
    }

    public Integer getAvailableQty() {
        return availableQty;
    }

    public void setAvailableQty(Integer availableQty) {
        this.availableQty = availableQty;
    }

    public Integer getSampleStatus() {
        return sampleStatus;
    }

    public void setSampleStatus(Integer sampleStatus) {
        this.sampleStatus = sampleStatus;
    }

    public String getHlModel() {
        return hlModel;
    }

    public void setHlModel(String hlModel) {
        this.hlModel = hlModel;
    }

    public Integer getEnuu() {
        return enuu;
    }

    public void setEnuu(Integer enuu) {
        this.enuu = enuu;
    }

    public String getMaterialCode() {
        return materialCode;
    }

    public void setMaterialCode(String materialCode) {
        this.materialCode = materialCode;
    }
}
