package com.uas.erp.schedular.mall.domain;

import java.util.Objects;

/**
 * 产品库存列表
 * @author zhaoy
 * @create 2019-05-07 18:10
 */
public class ProductUpdate {

    String materialCode; // 物料编号
    Integer availableQty; // 剩余库存

    Integer mpq; // 最小包装数量
    Integer moq; // 最小起订量
    String invoiceModel; // 开票型号
    String invoiceName; // 开票名称
    double price; // 销售标准价

    public String getInvoiceName() {
        return invoiceName;
    }

    public void setInvoiceName(String invoiceName) {
        this.invoiceName = invoiceName;
    }

    public Integer getMpq() {
        return mpq;
    }

    public void setMpq(Integer mpq) {
        this.mpq = mpq;
    }

    public Integer getMoq() {
        return moq;
    }

    public void setMoq(Integer moq) {
        this.moq = moq;
    }

    public String getInvoiceModel() {
        return invoiceModel;
    }

    public void setInvoiceModel(String invoiceModel) {
        this.invoiceModel = invoiceModel;
    }

    public double getPrice() {
        return price;
    }

    public void setPrice(double price) {
        this.price = price;
    }

    public String getMaterialCode() {
        return materialCode;
    }

    public void setMaterialCode(String materialCode) {
        this.materialCode = materialCode;
    }

    public Integer getAvailableQty() {
        return availableQty;
    }

    public void setAvailableQty(Integer availableQty) {
        this.availableQty = availableQty;
    }

    public ProductUpdate(String materialCode, Integer availableQty) {
        this.materialCode = materialCode;
        this.availableQty = availableQty;
    }

    public ProductUpdate(String materialCode, Integer availableQty, Integer mpq, Integer moq, String invoiceModel, String invoiceName, double price) {
        this.materialCode = materialCode;
        this.availableQty = availableQty;
        this.mpq = mpq;
        this.moq = moq;
        this.invoiceModel = invoiceModel;
        this.invoiceName = invoiceName;
        this.price = price;
    }

    public ProductUpdate() {
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;
        ProductUpdate that = (ProductUpdate) o;
        return materialCode.equals(that.materialCode);
    }

    @Override
    public int hashCode() {
        return Objects.hash(materialCode);
    }
}
