package com.uas.erp.schedular.publicinquiry.domain;

import java.util.Date;
import java.util.Set;

public class PublicInquiry {

    /**
     * id
     */
    private Long id;

    /**
     * 询价单所属企业UU
     */
    private Long enUU;

    /**
     * 企业名称（方便搜索）
     */
    private String enName;

    /**
     * 询价单所属用户UU
     */
    private Long recorderUU;

    /**
     * 流水号
     */
    private String code;

    /**
     * 单据归属日期
     */
    private Date date;

    /**
     * 录入人
     */
    private String recorder;

    /**
     * 审核人
     */
    private String auditor;

    /**
     * 报价截止日期
     */
    private Date endDate;

    /**
     * 备注
     */
    private String remark;

    /**
     * 环保要求
     */
    private String environment;

    /**
     * 价格类型
     */
    private String priceType;

    /**
     * 询价明细
     */
    private Set<PublicInquiryItem> inquiryItems;

    /**
     * 来源系统单据ID
     */
    private Long sourceId;

    /**
     * 附件
     */
    private Set<Attach> attachs;

    /**
     * 客户已提交 1 为已提交 否则为未提交
     */
    private Short check;

    /**
     * 是否过期 1已过期 非1 未过期
     */
    private Short overdue;

    /**
     * 是否公开<br>
     * 1、 公共<br>
     * 0、 不用开
     */
    private Short isOpen;

    /**
     * 应用来源，主要是为了平台公共询价做处理
     */
    private String sourceApp;

    /**
     * 收货地址
     */
    private String ship;

    /**
     * 是否开票<br>
     * 1. 是<br>
     * 0. 否
     */
    private Short invoice;

    /**
     * 询价类型
     */
    private String inquirytype;

    /**
     * 询价种类（公共或其他）
     */
    private String kind;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getEnUU() {
        return enUU;
    }

    public void setEnUU(Long enUU) {
        this.enUU = enUU;
    }

    public String getEnName() {
        return enName;
    }

    public void setEnName(String enName) {
        this.enName = enName;
    }

    public Long getRecorderUU() {
        return recorderUU;
    }

    public void setRecorderUU(Long recorderUU) {
        this.recorderUU = recorderUU;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public Date getDate() {
        return date;
    }

    public void setDate(Date date) {
        this.date = date;
    }

    public String getRecorder() {
        return recorder;
    }

    public void setRecorder(String recorder) {
        this.recorder = recorder;
    }

    public String getAuditor() {
        return auditor;
    }

    public void setAuditor(String auditor) {
        this.auditor = auditor;
    }

    public Date getEndDate() {
        return endDate;
    }

    public void setEndDate(Date endDate) {
        this.endDate = endDate;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public String getEnvironment() {
        return environment;
    }

    public void setEnvironment(String environment) {
        this.environment = environment;
    }

    public String getPriceType() {
        return priceType;
    }

    public void setPriceType(String priceType) {
        this.priceType = priceType;
    }

    public Set<PublicInquiryItem> getInquiryItems() {
        return inquiryItems;
    }

    public void setInquiryItems(Set<PublicInquiryItem> inquiryItems) {
        this.inquiryItems = inquiryItems;
    }

    public Long getSourceId() {
        return sourceId;
    }

    public void setSourceId(Long sourceId) {
        this.sourceId = sourceId;
    }

    public Set<Attach> getAttachs() {
        return attachs;
    }

    public void setAttachs(Set<Attach> attachs) {
        this.attachs = attachs;
    }

    public Short getCheck() {
        return check;
    }

    public void setCheck(Short check) {
        this.check = check;
    }

    public Short getOverdue() {
        return overdue;
    }

    public void setOverdue(Short overdue) {
        this.overdue = overdue;
    }

    public Short getIsOpen() {
        return isOpen;
    }

    public void setIsOpen(Short isOpen) {
        this.isOpen = isOpen;
    }

    public String getSourceApp() {
        return sourceApp;
    }

    public void setSourceApp(String sourceApp) {
        this.sourceApp = sourceApp;
    }

    public String getShip() {
        return ship;
    }

    public void setShip(String ship) {
        this.ship = ship;
    }

    public Short getInvoice() {
        return invoice;
    }

    public void setInvoice(Short invoice) {
        this.invoice = invoice;
    }

    public String getInquirytype() {
        return inquirytype;
    }

    public void setInquirytype(String inquirytype) {
        this.inquirytype = inquirytype;
    }

    public String getKind() {
        return kind;
    }

    public void setKind(String kind) {
        this.kind = kind;
    }
}
