package com.uas.erp.schedular.repository;

import com.uas.erp.schedular.entity.MasterTaskConfigEntity;
import com.uas.erp.schedular.entity.MasterTaskConfigId;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.stereotype.Repository;

import java.util.List;

/**
 * Created by Pro1 on 2017/7/26.
 */
@Repository
public interface MasterTaskConfigRepository extends JpaRepository<MasterTaskConfigEntity, MasterTaskConfigId>, JpaSpecificationExecutor<MasterTaskConfigEntity>{

    List<MasterTaskConfigEntity> findByEnabled(boolean enabled);

    List<MasterTaskConfigEntity> findByMasterName(String masterName);

    int countByModule(String module);

    int countByMasterNameAndModule(String masterName, String module);

    List<MasterTaskConfigEntity> findByMasterNameAndEnabled(String masterName, boolean enabled);

    int countByModuleAndEnabled(String module, boolean enabled);

    int countByMasterNameAndModuleAndEnabled(String masterName, String module, boolean enabled);

    MasterTaskConfigEntity findByBeanNameAndMethodNameAndMasterName(String beanName, String methodName, String masterName);

    List<MasterTaskConfigEntity> findByModule(String module);

    List<MasterTaskConfigEntity> findByMasterNameAndModule(String masterName, String module);

    List<MasterTaskConfigEntity> findByBeanNameAndMethodName(String beanName, String methodName);

}
