package com.uas.erp.schedular.service;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.TypeReference;
import com.uas.erp.schedular.entity.Master;
import com.uas.erp.schedular.web.ResultListWrap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import java.util.List;

/**
 * Created by Pro1 on 2017/7/31.
 */
@Service
public class MasterService {

    @Autowired
    private RestTemplate restTemplate;

    @Autowired
    private SettingService settingService;

    private String getUrl() {
        return settingService.getValue("api.database.url");
    }

    public List<Master> getMasters() {
        try {
            String resultStr = restTemplate.getForObject(getUrl() + "/v1/master/list?cloudEnabled=true", String.class);
            ResultListWrap<Master> result = JSON.parseObject(resultStr, new TypeReference<ResultListWrap<Master>>(Master.class) {
            });
            if (result.isSuccess()) {
                return result.getContent();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

}
