package com.uas.erp.schedular.service;

import com.uas.erp.schedular.entity.Setting;
import com.uas.erp.schedular.repository.SettingRepository;
import com.uas.erp.schedular.support.BackupDBFileUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * Created by Pro1 on 2017/7/26.
 */
@Service
public class SettingService {

    @Autowired
    private SettingRepository settingRepository;

    public List<Setting> findAll() {
        return settingRepository.findAll();
    }

    public Setting findOne(String key) {
        return settingRepository.findOne(key);
    }

    public String getValue(String key) {
        Setting setting = settingRepository.findOne(key);
        return null != setting ? setting.getValue() : null;
    }

    public void save(Setting setting) {
        settingRepository.save(setting);
        BackupDBFileUtils.createFile();
    }

    public void save(List<Setting> settings) {
        settingRepository.save(settings);
    }

    public void delete(Setting setting) {
        settingRepository.delete(setting);
        BackupDBFileUtils.createFile();
    }

}
