package com.uas.erp.schedular.task.logging;

import com.fasterxml.jackson.annotation.JsonIgnore;

import javax.persistence.*;

/**
 * Created by Pro1 on 2017/7/31.
 * 借助logback记录task执行日志
 */
@Entity
@Table(name = "logging_event", indexes = {
        @Index(name = "idx_master_bean_method", columnList = "arg2,arg0,arg1"),
        @Index(name = "idx_level", columnList = "level_string")})
public class LoggingEvent {

    @Column(name = "timestmp")
    private long endTime;

    @Column(name = "formatted_message", length = 2000)
    private String message;

    @Column(name = "logger_name")
    private String loggerName;

    @Column(name = "level_string")
    private String level;

    @Column(name = "thread_name")
    private String threadName;

    @Column(name = "reference_flag")
    private int referenceFlag;

    @Column(name = "arg0")
    private String beanName;

    @Column(name = "arg1")
    private String methodName;

    @Column(name = "arg2")
    private String masterName;

    @Column(name = "arg3")
    private Long startTime;

    @Column(name = "caller_filename")
    private String callerFilename;

    @Column(name = "caller_class")
    private String callerClass;

    @Column(name = "caller_method")
    private String callerMethod;

    @Column(name = "caller_line")
    private String callerLine;

    @Id
    @GeneratedValue
    @Column(name = "event_id")
    private long id;

    public long getEndTime() {
        return endTime;
    }

    public void setEndTime(long endTime) {
        this.endTime = endTime;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    @JsonIgnore
    public String getLoggerName() {
        return loggerName;
    }

    public void setLoggerName(String loggerName) {
        this.loggerName = loggerName;
    }

    public String getLevel() {
        return level;
    }

    public void setLevel(String level) {
        this.level = level;
    }

    @JsonIgnore
    public String getThreadName() {
        return threadName;
    }

    public void setThreadName(String threadName) {
        this.threadName = threadName;
    }

    @JsonIgnore
    public int getReferenceFlag() {
        return referenceFlag;
    }

    public void setReferenceFlag(int referenceFlag) {
        this.referenceFlag = referenceFlag;
    }

    public String getBeanName() {
        return beanName;
    }

    public void setBeanName(String beanName) {
        this.beanName = beanName;
    }

    public String getMethodName() {
        return methodName;
    }

    public void setMethodName(String methodName) {
        this.methodName = methodName;
    }

    public String getMasterName() {
        return masterName;
    }

    public void setMasterName(String masterName) {
        this.masterName = masterName;
    }

    public Long getStartTime() {
        return startTime;
    }

    public void setStartTime(Long startTime) {
        this.startTime = startTime;
    }

    @JsonIgnore
    public String getCallerFilename() {
        return callerFilename;
    }

    public void setCallerFilename(String callerFilename) {
        this.callerFilename = callerFilename;
    }

    @JsonIgnore
    public String getCallerClass() {
        return callerClass;
    }

    public void setCallerClass(String callerClass) {
        this.callerClass = callerClass;
    }

    @JsonIgnore
    public String getCallerMethod() {
        return callerMethod;
    }

    public void setCallerMethod(String callerMethod) {
        this.callerMethod = callerMethod;
    }

    @JsonIgnore
    public String getCallerLine() {
        return callerLine;
    }

    public void setCallerLine(String callerLine) {
        this.callerLine = callerLine;
    }

    public long getId() {
        return id;
    }

    public void setId(long id) {
        this.id = id;
    }
}
