package com.uas.erp.schedular.task.logging;

import com.uas.erp.schedular.entity.MasterTaskConfigId;
import com.uas.erp.schedular.task.support.Method;
import com.uas.erp.schedular.util.ObjectUtil;
import org.slf4j.event.Level;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Repository;
import org.springframework.util.StringUtils;

import java.util.Map;

/**
 * Created by Pro1 on 2017/8/24.
 */
@Repository
public class LoggingEventStatRepository {

    @Autowired
    private JdbcTemplate jdbcTemplate;

    private String wrapSql(MasterTaskConfigId configId, String module, String role) {
        StringBuffer sql = new StringBuffer("from logging_event,master_task_config_entity where master_name=arg2 and bean_name=arg0 and method_name=arg1");
        if (null != configId) {
            if (!StringUtils.isEmpty(configId.getMasterName())) {
                sql.append(" and master_name='").append(configId.getMasterName()).append("'");
            }
            if (!StringUtils.isEmpty(configId.getBeanName())) {
                sql.append(" and bean_name='").append(configId.getBeanName()).append("'");
            }
            if (!StringUtils.isEmpty(configId.getMethodName())) {
                sql.append(" and method_name='").append(configId.getMethodName()).append("'");
            }
        }
        if (!StringUtils.isEmpty(module)) {
            sql.append(" and module='").append(module).append("'");
        }
        if (!StringUtils.isEmpty(role)) {
            sql.append(" and role='").append(role).append("'");
        }
        return sql.toString();
    }

    public double getDataCount(MasterTaskConfigId configId, String module, String role, Method method) {
        StringBuffer sql = new StringBuffer("select sum(to_number(formatted_message)) ");
        sql.append(wrapSql(configId, module, role));
        sql.append(" and transfer_method='").append(method.name()).append("'");
        sql.append(" and level_string in ('").append(Level.INFO.toString()).append("','").append(Level.WARN.toString()).append("')");
        return ObjectUtil.nvl(jdbcTemplate.queryForObject(sql.toString(), Double.class), 0D);
    }

    public int getLevelCount(MasterTaskConfigId configId, String module, String role, Level level) {
        StringBuffer sql = new StringBuffer("select count(*) ");
        sql.append(wrapSql(configId, module, role));
        sql.append(" and level_string='").append(level.toString()).append("'");
        return jdbcTemplate.queryForObject(sql.toString(), Integer.class);
    }

    public double getAverageTimeUsage(MasterTaskConfigId configId, String module, String role) {
        StringBuffer sql = new StringBuffer("select avg(timestmp-arg3) ");
        sql.append(wrapSql(configId, module, role));
        return ObjectUtil.nvl(jdbcTemplate.queryForObject(sql.toString(), Double.class), 0D);
    }

    public long getStartTime(MasterTaskConfigId configId, String module, String role) {
        StringBuffer sql = new StringBuffer("select min(arg3) ");
        sql.append(wrapSql(configId, module, role));
        return ObjectUtil.nvl(jdbcTemplate.queryForObject(sql.toString(), Long.class), 0L);
    }

    public long getEndTime(MasterTaskConfigId configId, String module, String role) {
        StringBuffer sql = new StringBuffer("select max(arg3) ");
        sql.append(wrapSql(configId, module, role));
        return ObjectUtil.nvl(jdbcTemplate.queryForObject(sql.toString(), Long.class), 0L);
    }

}
