package com.uas.erp.schedular.task.support;

import java.lang.reflect.Method;

/**
 * Created by Pro1 on 2017/7/26.
 */
public class TaskConfig {

    private String beanName;
    private Object bean;
    private Method method;
    private TaskMapping beanMapping;
    private TaskMapping methodMapping;

    public TaskConfig() {
    }

    public TaskConfig(Object bean, String beanName, Method method) {
        this.beanName = beanName;
        this.bean = bean;
        this.method = method;
        this.beanMapping = bean.getClass().getAnnotation(TaskMapping.class);
        this.methodMapping = method.getAnnotation(TaskMapping.class);
    }

    public Object getBean() {
        return bean;
    }

    public Method getMethod() {
        return method;
    }

    public String getBeanName() {
        return beanName;
    }

    public void setBeanName(String beanName) {
        this.beanName = beanName;
    }

    public void setBean(Object bean) {
        this.bean = bean;
    }

    public void setMethod(Method method) {
        this.method = method;
    }

    public TaskMapping getBeanMapping() {
        return beanMapping;
    }

    public void setBeanMapping(TaskMapping beanMapping) {
        this.beanMapping = beanMapping;
    }

    public TaskMapping getMethodMapping() {
        return methodMapping;
    }

    public void setMethodMapping(TaskMapping methodMapping) {
        this.methodMapping = methodMapping;
    }

    @Override
    public String toString() {
        return "TaskConfig{" +
                "beanName='" + beanName + '\'' +
                ", bean=" + bean +
                ", method=" + method +
                ", beanMapping=" + beanMapping +
                ", methodMapping=" + methodMapping +
                '}';
    }
}
