package com.uas.erp.schedular.task.support;

import java.lang.annotation.*;

/**
 * 可配置轮询任务，相对@Scheduled更灵活
 * Created by Pro1 on 2017/7/26.
 */
@Documented
@Target({ ElementType.METHOD, ElementType.TYPE })
@Retention(RetentionPolicy.RUNTIME)
public @interface TaskMapping {

    /**
     * 描述
     * @return
     */
    String title();

    /**
     * 默认是否开启
     * @return
     */
    boolean enabled() default false;

    /**
     * 默认定时表达式
     * @return
     */
    String cron() default "";

    /**
     * 默认轮询延迟
     * @return
     */
    long fixedDelay() default -1L;

    /**
     * 默认轮询周期
     * @return
     */
    long fixedRate() default -1L;

    /**
     * 模块
     * @return
     */
    String module() default "";

    /**
     * 角色
     * @return
     */
    Role role() default Role.PLAIN;

    /**
     * 上传、下载
     * @return
     */
    Method method() default Method.UPLOAD;

}
