package com.uas.erp.schedular.util;

import java.util.ArrayList;
import java.util.List;

/**
 * 数组工具类
 *
 * @author hejq
 * @date 2018-08-24 9:55
 */
public class ArrayUtil {

    /**
     * 集合大小拆分
     *
     * @param ary 数组
     * @param subSize 分割数量
     * @return List<List<T>>
     */
    public static <T> List<List<T>> splitAry(List<T> ary, int subSize) {
        int count = ary.size() % subSize == 0 ? ary.size() / subSize: ary.size() / subSize + 1;
        List<List<T>> subAryList = new ArrayList<List<T>>();
        for (int i = 0; i < count; i++) {
            int index = i * subSize;
            List<T> list = new ArrayList<T>();
            int j = 0;
            while (j < subSize && index < ary.size()) {
                list.add(ary.get(index++));
                j++;
            }
            subAryList.add(list);
        }
        return subAryList;
    }
}
