package com.uas.erp.schedular.util;

import org.springframework.beans.BeanUtils;
import org.springframework.util.ClassUtils;

import java.beans.PropertyDescriptor;
import java.util.*;
import java.util.concurrent.ConcurrentHashMap;

/**
 * Created by Pro1 on 2017/7/27.
 */
public class BeanUtil {

    static final ConcurrentHashMap<Class<?>, String[]> beanPropertiesCache = new ConcurrentHashMap<>();

    public static String[] getProperties(Class<?> targetCls) {
        String[] props = beanPropertiesCache.get(targetCls);
        if (null == props) {
            PropertyDescriptor[] descriptors = BeanUtils.getPropertyDescriptors(targetCls);
            List<String> writableFields = new ArrayList<String>();
            int i = 0;
            for (PropertyDescriptor descriptor : descriptors) {
                if (null != descriptor.getWriteMethod() && isNormalType(descriptor.getPropertyType())) {
                    writableFields.add(descriptor.getName());
                }
            }
            props = writableFields.toArray(new String[]{});
            beanPropertiesCache.put(targetCls, props);
        }
        return props;
    }

    private static boolean isNormalType(Class<?> type) {
        return Number.class.isAssignableFrom(type) || type.isAssignableFrom(String.class)
                || Date.class.isAssignableFrom(type) || ClassUtils.isPrimitiveOrWrapper(type);
    }

}
