package com.uas.erp.schedular.util;

import org.springframework.core.io.ClassPathResource;
import org.springframework.util.StreamUtils;
import org.springframework.util.StringUtils;

import java.io.IOException;
import java.nio.charset.Charset;

/**
 * Created by Pro1 on 2017/7/26.
 */
public class StringUtil {

    /**
     * 如果一个对象为空，则返回另一个对象
     * @param object
     * @param nvlValue
     * @return
     */
    public static String nvl(Object object, String nvlValue) {
        return StringUtils.isEmpty(object) ? nvlValue : object.toString();
    }

    /**
     * 如果一个对象为空，则返回空字符串
     * @param object
     * @return
     */
    public static String nvl(Object object) {
        return nvl(object, "");
    }

    public static String copyResource(String resourcePath) throws IOException {
        ClassPathResource resource = new ClassPathResource(resourcePath);
        if (resource.exists()) {
            return StreamUtils.copyToString(resource.getInputStream(), Charset.forName("UTF-8"));
        }
        return null;
    }

    /**
     * 截取字符串
     * @param str
     * @param beginIndex
     * @param endIndex
     * @return
     */
    public static String substr(String str, int beginIndex, int endIndex) {
        if (null == str) {
            return null;
        }
        int maxIndex = str.length();
        if (endIndex > maxIndex) {
            endIndex = maxIndex;
        }
        return str.substring(beginIndex, endIndex);
    }

    /**
     * 处理特殊字符
     *
     * @param str 字符串
     * @return
     */
    public static String speSymbols(String str) {
        if (null == str) {
            return "";
        }
        if (str.contains("'")) {// 针对单引号的处理
            str = str.replaceAll("'", "''");
        }
        return str;
    }
}
