package com.uas.erp.test;

import com.uas.erp.schedular.UasSchedulingApplication;
import com.uas.erp.schedular.b2b.task.*;
import com.uas.erp.schedular.entity.Master;
import com.uas.erp.schedular.publicproduct.task.ProdTask;
import com.uas.erp.schedular.util.ContextHolder;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.context.ApplicationContext;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

/**
 * @Author: huj
 * @Date: Created in 8:56 2018/6/28.
 */
@RunWith(SpringJUnit4ClassRunner.class)
@SpringBootTest(webEnvironment = SpringBootTest.WebEnvironment.NONE, classes = UasSchedulingApplication.class)
public class PurchaseChangeTest extends AbstractTask {

    @Autowired
    SaleDownChangeTask saleDownChangeTask;

    @Autowired
    ApplicationContext applicationContext;

    @Autowired
    SaleDownTask saleDownTask;

    @Autowired
    PurchaseTask purchaseTask;

    @Autowired
    ProdCheckTask prodCheckTask;


    @Autowired
    InquiryTask inquiryTask;

    @Autowired
    PurchaseSampleTask purchaseSampleTask;

    @Autowired
    MakeTask makeTask;

    @Autowired
    PurchaseNotifyTask purchaseNotifyTask;


    @Autowired
    CheckTransTask checkTransTask;

    @Autowired
    PurchaseProdInOutTask purchaseProdInOutTask;

    @Autowired
    ProdTask prodTask;

    @Autowired
    PurchaseChangeTask purchaseChangeTask;

    @Autowired
    OrderCheckTask orderCheckTask;

    @Autowired
    SaleProdInOutDownTask saleProdInOutDownTask;

    @Autowired
    MakeProdInOutTask makeProdInOutTask;

    @Autowired
    InquiryMouldTask inquiryMouldTask;

    @Autowired
    SaleAPCheckTask saleAPCheckTask;


    @Test
    public void uploadPurchaseChangeTest() {

        Master master = new Master();
        master.setMa_user("UAS");
        master.setMa_uu(10041166L);
        master.setMa_accesssecret("2c1ea0898633796fe050007f01002ea6");
        master.setMa_env("test");
        master.setMa_name("UAS");

        ContextHolder.setMaster(master);
        purchaseNotifyTask.downloadAcceptNotify();
    }

    // 胜芳SAAS_10041559
    @Test
    public void uploadPurchaseChangeTestSF() {

        Master master = new Master();
        master.setMa_user("SAAS_10041559");
        master.setMa_uu(10041559L);
        master.setMa_accesssecret("2c1ea089876b796fe050007f01002ea6");
        master.setMa_env("test");
        master.setMa_name("SAAS_10041559");

        ContextHolder.setMaster(master);
        purchaseTask.downloadhasIssued();
    }

    //天派电子
    @Test
    public void uploadPurchaseChangeTestTianPai() {

        Master master = new Master();
        master.setMa_user("skypine_el");
        master.setMa_uu(10006098L);
        master.setMa_accesssecret("2c1ea0898035796fe050007f01002ea6");
        master.setMa_env("prod");
        master.setMa_name("skypine_el");
        ContextHolder.setMaster(master);
        purchaseTask.uploadPurchase();
    }

    //欧盛
    @Test
    public void uploadPurchaseChangeTestOusheng() {

        Master master = new Master();
        master.setMa_user("OSAUTO");
        master.setMa_uu(10046539L);
        master.setMa_accesssecret("aff1d9aac85042a491b21ef3d382abd1");
        master.setMa_env("prod");
        master.setMa_name("OSAUTO");
        ContextHolder.setMaster(master);
        purchaseTask.uploadPurchase();
    }

    //英唐智控
    @Test
    public void uploadPurchaseChangeTestYt() {

        Master master = new Master();
        master.setMa_user("YITOA_INTCON");
        master.setMa_uu(10041961L);
        master.setMa_accesssecret("2c1ea08988a6796fe050007f01002ea6");
        master.setMa_env("prod");
        master.setMa_name("YITOA_INTCON");
        ContextHolder.setMaster(master);
        saleProdInOutDownTask.downloadSaleProdInOut();
    }

    //漳州万利达
    @Test
    public void uploadPurchaseChangeTestZZ() {

        Master master = new Master();
        master.setMa_user("N_MALATA_ZZ");
        master.setMa_uu(10048097L);
        master.setMa_accesssecret("6952e099cb75a780e050007f01000762");
        master.setMa_env("prod");
        master.setMa_name("N_MALATA_ZZ");
        ContextHolder.setMaster(master);
        purchaseProdInOutTask.uploadProdInOut();
    }

    //深圳华商龙
    @Test
    public void uploadPurchaseChangeTestHSL() {

        Master master = new Master();
        master.setMa_user("N_HUASL_SZ");
        master.setMa_uu(10000666L);
        master.setMa_accesssecret("2c1ea0897c1a796fe050007f01002ea6");
        master.setMa_env("prod");
        master.setMa_name("N_HUASL_SZ");
        ContextHolder.setMaster(master);
        orderCheckTask.checkSaleMain();
    }

    //香港华商龙
    @Test
    public void uploadPurchaseChangeTestHKHSL() {

        Master master = new Master();
        master.setMa_user("N_HUASL");
        master.setMa_uu(10041191L);
        master.setMa_accesssecret("2c1ea0898649796fe050007f01002ea6");
        master.setMa_env("prod");
        master.setMa_name("N_HUASL");
        ContextHolder.setMaster(master);
        prodTask.uploadProduct();
    }

    //数码科技
    @Test
    public void uploadPurchaseChangeTestYITOA_TECHNO() {

        Master master = new Master();
        master.setMa_user("YITOA_TECHNO");
        master.setMa_uu(10044101L);
        master.setMa_accesssecret("1d6824b48a2a437eb3c810b59659ccbc");
        master.setMa_env("prod");
        master.setMa_name("YITOA_TECHNO");
        ContextHolder.setMaster(master);
        saleAPCheckTask.downloadSaleARCheck();
    }

    @Test
    public void test() {
        for (int i = 0;i < 10;i++) {
            uploadPurchaseChangeTestHKHSL();
        }
    }
}
