package com.uas.erp.test;

import com.uas.erp.schedular.b2b.domain.DeputyOrder;
import com.uas.erp.schedular.b2b.domain.DeputyOrderItem;
import com.uas.erp.schedular.database.SqlTemplate;
import org.junit.Test;
import org.springframework.util.FileCopyUtils;
import org.springframework.util.StreamUtils;

import java.io.FileOutputStream;
import java.io.FileReader;
import java.nio.charset.Charset;
import java.util.*;

/**
 * Created by Pro1 on 2017/8/10.
 */
public class XmlTest {

//    @Test
    public void parseXml() throws Exception{
        String xmlStr = FileCopyUtils.copyToString(new FileReader("E:\\file\\test\\deputyOrder.xml"));
        Map<String, Object> model = new HashMap<>();
        model.put("orders", getOrders(2));
        long start = System.currentTimeMillis();
        String str = SqlTemplate.fromXml(xmlStr, model);
        StreamUtils.copy(str, Charset.defaultCharset(), new FileOutputStream("E:\\file\\test\\deputyOrder.sql"));
        System.out.println("used: " + (System.currentTimeMillis() - start));
    }

    private List<DeputyOrder> getOrders(int count) {
        List<DeputyOrder> orders = new ArrayList<>();
        for (int i = 0; i < count; i++) {
            DeputyOrder order = new DeputyOrder();
            order.setSalecode("SS000" + i);
            order.setSalepocode("PO000" + i);
            order.setEntrydate(new Date());
            order.setCurrency("RMB");
            order.setCode("X000" + i);
            order.setEnuu((long) 1000001);
            order.setTervendor("测试供应商");
            order.setMadealcode("M000" + i);
            order.setMadealdate(new Date());
            List<DeputyOrderItem> items = new ArrayList<>();
            for (int j = 0; j < 2; j++) {
                DeputyOrderItem item = new DeputyOrderItem();
                item.setProdname("测试物料" + i + "-" + j);
                item.setProdcode("P-" + i + "-" + j);
                item.setProdspec(item.getProdcode());
                item.setProdbrand("品牌-" + i);
                item.setDetno(j + 1);
                item.setUnitprice(1.23);
                item.setTotalprice((double)123);
                item.setAmount(100);
                items.add(item);
            }
            order.setDeputyOrderItems(items);
            orders.add(order);
        }
        return orders;
    }

}
